diff --git a/contrib/amd/amd/info_ndbm.c b/contrib/amd/amd/info_ndbm.c
index 91cb8e0..8a52ba9 100644
--- a/contrib/amd/amd/info_ndbm.c
+++ b/contrib/amd/amd/info_ndbm.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1989 Jan-Simon Pendry
  * Copyright (c) 1989 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1989 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_ndbm.c,v 1.2 1999/01/10 21:53:46 ezk Exp $
+ * File: am-utils/amd/info_ndbm.c
  *
  */
 
@@ -86,8 +85,8 @@ ndbm_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
 #ifdef DBM_SUFFIX
     char dbfilename[256];
 
-    strcpy(dbfilename, map);
-    strcat(dbfilename, DBM_SUFFIX);
+    xstrlcpy(dbfilename, map, sizeof(dbfilename));
+    xstrlcat(dbfilename, DBM_SUFFIX, sizeof(dbfilename));
     error = stat(dbfilename, &stb);
 #else /* not DBM_SUFFIX */
     error = fstat(dbm_pagfno(db), &stb);
@@ -117,14 +116,14 @@ ndbm_init(mnt_map *m, char *map, time_t *tp)
 #ifdef DBM_SUFFIX
     char dbfilename[256];
 
-    strcpy(dbfilename, map);
-    strcat(dbfilename, DBM_SUFFIX);
+    xstrlcpy(dbfilename, map, sizeof(dbfilename));
+    xstrlcat(dbfilename, DBM_SUFFIX, sizeof(dbfilename));
     error = stat(dbfilename, &stb);
 #else /* not DBM_SUFFIX */
     error = fstat(dbm_pagfno(db), &stb);
 #endif /* not DBM_SUFFIX */
     if (error < 0)
-      *tp = clocktime();
+      *tp = clocktime(NULL);
     else
       *tp = stb.st_mtime;
     dbm_close(db);
diff --git a/contrib/amd/amd/info_nis.c b/contrib/amd/amd/info_nis.c
index 17699d4..bcb87d5 100644
--- a/contrib/amd/amd/info_nis.c
+++ b/contrib/amd/amd/info_nis.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1989 Jan-Simon Pendry
  * Copyright (c) 1989 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1989 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_nis.c,v 1.5 1999/08/22 05:12:51 ezk Exp $
+ * File: am-utils/amd/info_nis.c
  *
  */
 
@@ -107,9 +106,7 @@ determine_nis_domain(void)
   }
   if (!*default_domain) {
     nis_not_running = 1;
-#ifdef DEBUG
     plog(XLOG_WARNING, "NIS domain name is not set.  NIS ignored.");
-#endif /* DEBUG */
     return ENOENT;
   }
   gopt.nis_domain = strdup(default_domain);
@@ -144,12 +141,8 @@ callback(int status, char *key, int kl, char *val, int vl, char *data)
       /* check what went wrong */
       int e = ypprot_err(status);
 
-#ifdef DEBUG
       plog(XLOG_ERROR, "yp enumeration of %s: %s, status=%d, e=%d",
 	   ncdp->ncd_map, yperr_string(e), status, e);
-#else /* not DEBUG */
-      plog(XLOG_ERROR, "yp enumeration of %s: %s", ncdp->ncd_map, yperr_string(e));
-#endif /* not DEBUG */
     }
     return TRUE;
   }
@@ -321,7 +314,7 @@ nis_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
     return ENOENT;
 
   default:
-    plog(XLOG_ERROR, "%s: %s", map, yperr_string(res));
+    plog(XLOG_ERROR, "nis_search: %s: %s", map, yperr_string(res));
     return EIO;
   }
 }
@@ -350,9 +343,7 @@ nis_init(mnt_map *m, char *map, time_t *tp)
     /* NIS server found */
     has_yp_order = 1;
     *tp = (time_t) order;
-#ifdef DEBUG
     dlog("NIS master for %s@%s has order %lu", map, gopt.nis_domain, (unsigned long) order);
-#endif /* DEBUG */
     break;
   case YPERR_YPERR:
     /* NIS+ server found ! */
@@ -361,9 +352,7 @@ nis_init(mnt_map *m, char *map, time_t *tp)
     if (yp_master(gopt.nis_domain, map, &master)) {
       return ENOENT;
     } else {
-#ifdef DEBUG
       dlog("NIS master for %s@%s is a NIS+ server", map, gopt.nis_domain);
-#endif /* DEBUG */
       /* Use fake timestamps */
       *tp = time(NULL);
     }
@@ -442,11 +431,9 @@ am_yp_all(char *indomain, char *inmap, struct ypall_callback *incallback)
 		&outvallen);
     XFREE(outkey_old);
   } while (!i);
-#ifdef DEBUG
   if (i) {
     dlog("yp_next() returned error: %s\n", yperr_string(i));
   }
-#endif /* DEBUG */
   if (i == YPERR_NOMORE)
     return 0;
   return i;
diff --git a/contrib/amd/amd/info_nisplus.c b/contrib/amd/amd/info_nisplus.c
index ea7a3d7..d392b48 100644
--- a/contrib/amd/amd/info_nisplus.c
+++ b/contrib/amd/amd/info_nisplus.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1989 Jan-Simon Pendry
  * Copyright (c) 1989 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1989 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_nisplus.c,v 1.2 1999/01/10 21:53:46 ezk Exp $
+ * File: am-utils/amd/info_nisplus.c
  *
  */
 
@@ -74,9 +73,7 @@ nisplus_callback(const nis_name key, const nis_object *value, voidp opaquedata)
   char *vp = strnsave(ENTRY_VAL(value, 1), ENTRY_LEN(value, 1));
   struct nis_callback_data *data = (struct nis_callback_data *) opaquedata;
 
-#ifdef DEBUG
   dlog("NISplus callback for <%s,%s>", kp, vp);
-#endif /* DEBUG */
 
   (*data->ncd_fn) (data->ncd_m, kp, vp);
 
@@ -95,6 +92,7 @@ nisplus_reload(mnt_map *m, char *map, void (*fn) ())
   nis_result *result;
   char *org;		/* if map does not have ".org_dir" then append it */
   nis_name map_name;
+  size_t l;
 
   org = strstr(map, NISPLUS_ORGDIR);
   if (org == NULL)
@@ -103,21 +101,20 @@ nisplus_reload(mnt_map *m, char *map, void (*fn) ())
     org = "";
 
   /* make some room for the NIS map_name */
-  map_name = xmalloc(strlen(map) + sizeof(NISPLUS_ORGDIR));
+  l = strlen(map) + sizeof(NISPLUS_ORGDIR);
+  map_name = xmalloc(l);
   if (map_name == NULL) {
     plog(XLOG_ERROR, "Unable to create map_name %s: %s",
 	 map, strerror(ENOMEM));
     return ENOMEM;
   }
-  sprintf(map_name, "%s%s", map, org);
+  xsnprintf(map_name, l, "%s%s", map, org);
 
   data.ncd_m = m;
   data.ncd_map = map_name;
   data.ncd_fn = fn;
 
-#ifdef DEBUG
   dlog("NISplus reload for %s", map);
-#endif /* DEBUG */
 
   result = nis_list(map_name,
 		    EXPAND_NAME | FOLLOW_LINKS | FOLLOW_PATH,
@@ -145,10 +142,8 @@ nisplus_search_callback(const nis_name key, const nis_object *value, voidp opaqu
 {
   struct nisplus_search_callback_data *data = (struct nisplus_search_callback_data *) opaquedata;
 
-#ifdef DEBUG
   dlog("NISplus search callback for <%s>", ENTRY_VAL(value, 0));
   dlog("NISplus search callback value <%s>", ENTRY_VAL(value, 1));
-#endif /* DEBUG */
 
   data->value = strnsave(ENTRY_VAL(value, 1), ENTRY_LEN(value, 1));
   return TRUE;
@@ -166,6 +161,7 @@ nisplus_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
   struct nisplus_search_callback_data data;
   nis_name index;
   char *org;		/* if map does not have ".org_dir" then append it */
+  size_t l;
 
   org = strstr(map, NISPLUS_ORGDIR);
   if (org == NULL)
@@ -174,14 +170,14 @@ nisplus_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
     org = "";
 
   /* make some room for the NIS index */
-  index = xmalloc(sizeof('[')	/* for opening selection criteria */
-		  +sizeof(NISPLUS_KEY)
-		  + strlen(key)
-		  + sizeof(']')	/* for closing selection criteria */
-		  +sizeof(',')	/* + 1 for , separator */
-		  +strlen(map)
-		  + sizeof(NISPLUS_ORGDIR)
-		  );
+  l = sizeof('[')		/* for opening selection criteria */
+    + sizeof(NISPLUS_KEY)
+    + strlen(key)
+    + sizeof(']')		/* for closing selection criteria */
+    + sizeof(',')		/* + 1 for , separator */
+    + strlen(map)
+    + sizeof(NISPLUS_ORGDIR);
+  index = xmalloc(l);
   if (index == NULL) {
     plog(XLOG_ERROR,
 	 "Unable to create index %s: %s",
@@ -189,14 +185,12 @@ nisplus_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
 	 strerror(ENOMEM));
     return ENOMEM;
   }
-  sprintf(index, "[%s%s],%s%s", NISPLUS_KEY, key, map, org);
+  xsnprintf(index, l, "[%s%s],%s%s", NISPLUS_KEY, key, map, org);
 
   data.key = key;
   data.value = NULL;
 
-#ifdef DEBUG
   dlog("NISplus search for %s", index);
-#endif /* DEBUG */
 
   result = nis_list(index,
 		    EXPAND_NAME | FOLLOW_LINKS | FOLLOW_PATH,
@@ -207,7 +201,7 @@ nisplus_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
   XFREE(index);
 
   if (result == NULL) {
-    plog(XLOG_ERROR, "%s: %s", map, strerror(ENOMEM));
+    plog(XLOG_ERROR, "nisplus_search: %s: %s", map, strerror(ENOMEM));
     return ENOMEM;
   }
 
@@ -220,11 +214,9 @@ nisplus_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
 
     if (data.value == NULL) {
       nis_object *value = result->objects.objects_val;
-#ifdef DEBUG
       dlog("NISplus search found <nothing>");
       dlog("NISplus search for %s: %s(%d)",
 	   map, nis_sperrno(result->status), result->status);
-#endif /* DEBUG */
 
       if (value != NULL)
 	data.value = strnsave(ENTRY_VAL(value, 1), ENTRY_LEN(value, 1));
@@ -233,28 +225,22 @@ nisplus_search(mnt_map *m, char *map, char *key, char **val, time_t *tp)
 
     if (*val) {
       error = 0;
-#ifdef DEBUG
       dlog("NISplus search found %s", *val);
-#endif /* DEBUG */
     } else {
       error = ENOENT;
-#ifdef DEBUG
       dlog("NISplus search found nothing");
-#endif /* DEBUG */
     }
 
     *tp = 0;
     break;
 
   case NIS_NOSUCHNAME:
-#ifdef DEBUG
     dlog("NISplus search returned %d", result->status);
-#endif /* DEBUG */
     error = ENOENT;
     break;
 
   default:
-    plog(XLOG_ERROR, "%s: %s", map, nis_sperrno(result->status));
+    plog(XLOG_ERROR, "nisplus_search: %s: %s", map, nis_sperrno(result->status));
     error = EIO;
     break;
   }
@@ -271,6 +257,7 @@ nisplus_init(mnt_map *m, char *map, time_t *tp)
   char *org;		/* if map does not have ".org_dir" then append it */
   nis_name map_name;
   int error = 0;
+  size_t l;
 
   org = strstr(map, NISPLUS_ORGDIR);
   if (org == NULL)
@@ -279,7 +266,8 @@ nisplus_init(mnt_map *m, char *map, time_t *tp)
     org = "";
 
   /* make some room for the NIS map_name */
-  map_name = xmalloc(strlen(map) + sizeof(NISPLUS_ORGDIR));
+  l = strlen(map) + sizeof(NISPLUS_ORGDIR);
+  map_name = xmalloc(l);
   if (map_name == NULL) {
     plog(XLOG_ERROR,
 	 "Unable to create map_name %s: %s",
@@ -287,7 +275,7 @@ nisplus_init(mnt_map *m, char *map, time_t *tp)
 	 strerror(ENOMEM));
     return ENOMEM;
   }
-  sprintf(map_name, "%s%s", map, org);
+  xsnprintf(map_name, l, "%s%s", map, org);
 
   result = nis_lookup(map_name, (EXPAND_NAME | FOLLOW_LINKS | FOLLOW_PATH));
 
@@ -300,10 +288,8 @@ nisplus_init(mnt_map *m, char *map, time_t *tp)
   }
 
   if (result->status != NIS_SUCCESS) {
-#ifdef DEBUG
     dlog("NISplus init <%s>: %s (%d)",
 	 map, nis_sperrno(result->status), result->status);
-#endif /* DEBUG */
 
     error = ENOENT;
   }
diff --git a/contrib/amd/amd/info_passwd.c b/contrib/amd/amd/info_passwd.c
index d367f38..c8bf388 100644
--- a/contrib/amd/amd/info_passwd.c
+++ b/contrib/amd/amd/info_passwd.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_passwd.c,v 1.2 1999/01/10 21:53:46 ezk Exp $
+ * File: am-utils/amd/info_passwd.c
  *
  */
 
@@ -151,11 +150,11 @@ passwd_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
     do {
       q = strrchr(p, '/');
       if (q) {
-	strcat(rhost, q + 1);
-	strcat(rhost, ".");
+	xstrlcat(rhost, q + 1, sizeof(rhost));
+	xstrlcat(rhost, ".", sizeof(rhost));
 	*q = '\0';
       } else {
-	strcat(rhost, p);
+	xstrlcat(rhost, p, sizeof(rhost));
       }
     } while (q);
 
@@ -176,11 +175,9 @@ passwd_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
       p++;
     else
       p = "type:=nfs;rfs:=/${var0}/${var1};rhost:=${var1};sublink:=${var2};fs:=${autodir}${var3}";
-    sprintf(val, "var0:=%s;var1:=%s;var2:=%s;var3:=%s;%s",
-	    dir+1, rhost, user, pw->pw_dir, p);
-#ifdef DEBUG
+    xsnprintf(val, sizeof(val), "var0:=%s;var1:=%s;var2:=%s;var3:=%s;%s",
+	      dir+1, rhost, user, pw->pw_dir, p);
     dlog("passwd_search: map=%s key=%s -> %s", map, key, val);
-#endif /* DEBUG */
     if (q)
       *q = '.';
     *pval = strdup(val);
diff --git a/contrib/amd/amd/info_union.c b/contrib/amd/amd/info_union.c
index d81602b..8f0631c 100644
--- a/contrib/amd/amd/info_union.c
+++ b/contrib/amd/amd/info_union.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_union.c,v 1.2 1999/01/10 21:53:47 ezk Exp $
+ * File: am-utils/amd/info_union.c
  *
  */
 
@@ -81,10 +80,12 @@ union_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
   char *mapd = strdup(map + UNION_PREFLEN);
   char **v = strsplit(mapd, ':', '\"');
   char **p;
+  size_t l;
 
   for (p = v; p[1]; p++) ;
-  *pval = xmalloc(strlen(*p) + 5);
-  sprintf(*pval, "fs:=%s", *p);
+  l = strlen(*p) + 5;
+  *pval = xmalloc(l);
+  xsnprintf(*pval, l, "fs:=%s", *p);
   XFREE(mapd);
   XFREE(v);
   return 0;
@@ -104,7 +105,7 @@ union_reload(mnt_map *m, char *map, void (*fn) (mnt_map *, char *, char *))
   (*fn) (m, strdup("/defaults"), strdup("type:=link;opts:=nounmount;sublink:=${key}"));
 
   for (dir = v; *dir; dir++) {
-    int dlen;
+    size_t l;
     struct dirent *dp;
 
     DIR *dirp = opendir(*dir);
@@ -112,11 +113,9 @@ union_reload(mnt_map *m, char *map, void (*fn) (mnt_map *, char *, char *))
       plog(XLOG_USER, "Cannot read directory %s: %m", *dir);
       continue;
     }
-    dlen = strlen(*dir);
+    l = strlen(*dir) + 5;
 
-#ifdef DEBUG
     dlog("Reading directory %s...", *dir);
-#endif /* DEBUG */
     while ((dp = readdir(dirp))) {
       char *val, *dpname = &dp->d_name[0];
       if (dpname[0] == '.' &&
@@ -124,11 +123,9 @@ union_reload(mnt_map *m, char *map, void (*fn) (mnt_map *, char *, char *))
 	   (dpname[1] == '.' && dpname[2] == '\0')))
 	continue;
 
-#ifdef DEBUG
       dlog("... gives %s", dp->d_name);
-#endif /* DEBUG */
-      val = xmalloc(dlen + 5);
-      sprintf(val, "fs:=%s", *dir);
+      val = xmalloc(l);
+      xsnprintf(val, l + 5, "fs:=%s", *dir);
       (*fn) (m, strdup(dp->d_name), val);
     }
     closedir(dirp);
@@ -138,9 +135,10 @@ union_reload(mnt_map *m, char *map, void (*fn) (mnt_map *, char *, char *))
    * Add wildcard entry
    */
   {
-    char *val = xmalloc(strlen(dir[-1]) + 5);
+    size_t l = strlen(*(dir-1)) + 5;
+    char *val = xmalloc(l);
 
-    sprintf(val, "fs:=%s", dir[-1]);
+    xsnprintf(val, l, "fs:=%s", *(dir-1));
     (*fn) (m, strdup("*"), val);
   }
   XFREE(mapd);
